

var baud = 115200;


var LDBuf = [];
var toLDbuf = 0;
var ldBufC  = 0;

var SeTBuf = [];
var toSeTbuf = 0;
var SeTBufC  = 0;



var live_data_active = 1;
var readSerial = 1;
var connId = [];


var MinCommand = 0;
var MaxCommand = 0;
var StartAt = 10;
var SoftStart = 0;
var BrakeForce = 0;
var SpinDir = 0;
var AFW = 1;
var inpSig = 0;
var PWMin = 0;
var PWMout = 5;
var timing = 2;
var slowP = 7;
var slowVolt = 0;
var cutVolt = 0;
var reversible = 0;
var Mpole = 6;
var I2Cadr = 41;
var CalibCL = 0;
var CLMode = 0;
var CP = 20;
var CI = 20;


var startB = 0;
var stopB = 0;
var readB = 0;
var writeB = 0;

function openPort(ports){
	live_data_active = 0;
	startB = document.getElementById('start');
	stopB = document.getElementById('stop');
	readB = document.getElementById('read');
	writeB = document.getElementById('write');
	
	startB.onclick = function(){startLD();};
	stopB.onclick = function(){stopLD();};
	
	readB.onclick = function(){readIt = 1;Write('B');};
	writeB.onclick = function(){WriteSettings();};
	
	
	document.getElementById('close').innerHTML = '';
	document.getElementById('comsel').innerHTML = '';
	var portwahl = document.createElement('select');
	portwahl.onchange = function(){
		openSerial(this.value);
	};
	portwahl.id = 'comselin';
	var portOpt = document.createElement('option');
	portOpt.value = '';
	portOpt.innerHTML = 'Select com Port';
	portwahl.appendChild(portOpt);
	for(var i in ports){
		var portOpt = document.createElement('option');
		portOpt.value = ports[i].path;
		portOpt.innerHTML = ports[i].path;
		
		portwahl.appendChild(portOpt);
	}
	document.getElementById('comsel').appendChild(portwahl);
	setConfig(MinCommand,MaxCommand,StartAt,SoftStart,BrakeForce,SpinDir,AFW,inpSig ,PWMin,PWMout,timing,slowP,slowVolt,cutVolt,reversible,CLMode,CalibCL,I2Cadr,CP,CI,Mpole);
	
	
	var refresh = document.createElement('input');
	refresh.type = 'button';
	refresh.value = 'Refresh';
	refresh.style.fontSize = '11px';
	refresh.style.width = '80px';
	refresh.onclick = function(){
		chrome.serial.getDevices(function(ports){
			openPort(ports);
		});
	}
	document.getElementById('close').appendChild(refresh);
}
var initDone = 0;
function openSerial(portVal){
	document.getElementById('close').innerHTML = '';
	if(portVal == '') return;
	document.getElementById('comsel').removeChild(document.getElementById('comselin'));
        chrome.serial.connect(portVal, {bitrate: baud}, function (cInfo) {serOpen(cInfo);});
	if(initDone == 0){
		chrome.serial.onReceive.addListener(pullBuf);
	}	
	
	var closeComm = document.createElement('input');
	closeComm.type = 'button';
	closeComm.value = 'Close COM';
	closeComm.style.fontSize = '11px';
	closeComm.style.width = '80px';
	closeComm.onclick = function(){
		startB.setAttribute("disabled","disabled");
		stopB.setAttribute("disabled","disabled");
		readB.setAttribute("disabled","disabled");
		writeB.setAttribute("disabled","disabled");
		chrome.serial.disconnect(connId.connectionId, function(){chrome.serial.getDevices(function(ports){
			openPort(ports);
		});});
	}
	document.getElementById('close').appendChild(closeComm);
	saledPort  = portVal;
	var opening = document.createElement('h2');
	opening.innerHTML ="selecting port: "+portVal;
	opening.id="opening";
	document.body.appendChild(opening);
	startB.removeAttribute("disabled");
	stopB.removeAttribute("disabled");
	readB.removeAttribute("disabled");
	writeB.removeAttribute("disabled");

}

function serOpen(cInfo){
	connId = cInfo;
	if(document.getElementById('opening')){
		document.body.removeChild(document.getElementById('opening'));
	}
	document.getElementById('comsel').innerHTML = saledPort;
	
	initGUI();
}


function Write(data){
	chrome.serial.send(connId.connectionId, str2ab(data), onWrite);
	//chrome.serial.flush(connId.connectionId, onFlush);
}
function onWrite(){
	
}
function onFlush(){
	
}

function pullBuf(info){
	checkComm(info);
}


var canvasCont = 0;
//_______________________________________________________________________//
var readIt = 0;
function initGUI(){
	readIt = 1;
	Write('B');
	pullData();
	if(initDone == 0){
		liverun = window.setInterval(pullData,80);
		initDone = 1;
	}
	canvasCont = document.getElementById('live').getContext('2d');
}

function pullData(){
	if(!live_data_active) return;
	Write('A');
}

var recived = 0;
var TMP_buff = [];
function checkComm(readInfo){
	if (readInfo.data.byteLength > 0) {
		var data = new Uint8Array(readInfo.data);
		
		
		for(var i = 0; i < data.length; i++){
			if(live_data_active){
				if(data[i] == 65 && toLDbuf == 0){
					TMP_buff = [];
					toLDbuf = 1;
					ldBufC  = 0;
					continue;
				}
				if(toLDbuf){
					TMP_buff[ldBufC] = data[i];
					ldBufC++;
				}
				if(ldBufC > 15 && toLDbuf){
					toLDbuf = 0;
					LDBuf = TMP_buff;
					checkLiveData();
				}
			}
			
			if(readIt){
				if(data[i] == 66 && toSeTbuf == 0){
					TMP_buff = [];
					toSeTbuf = 1;
					SeTBufC  = 0;
					continue;
				}
				if(toSeTbuf){
					TMP_buff[SeTBufC] = data[i];
					SeTBufC++;
				}
				if(SeTBufC > 30 && toSeTbuf){
					toSeTbuf = 0;
					SeTBuf = TMP_buff;
					checkSetupData();
					readIt = 0;
				}
			}
		}
	}
};


var TMP  = [];
var PWM = [];
var RPM  = [];
var Rrpm = 0;
var Volt  = [];
var Curr  = [];


function checkSetupData(){
	
	MinCommand = ((SeTBuf[0]<<8) + (SeTBuf[1]&0xff))-1000;
	MinCommand = Math.round(MinCommand/5);
	MaxCommand = 2000-((SeTBuf[2]<<8) + (SeTBuf[3]&0xff));
	MaxCommand = Math.round(MaxCommand/5);
	StartAt = ((SeTBuf[4]<<8) + (SeTBuf[5]&0xff))-1050;
	StartAt = Math.round(StartAt/5);
	SoftStart = ((SeTBuf[6]<<8) + (SeTBuf[7]&0xff));
	BrakeForce = Math.round(((SeTBuf[8]<<8) + (SeTBuf[9]&0xff))/5);
	SpinDir = SeTBuf[10];
	AFW = SeTBuf[11];
	inpSig = SeTBuf[12];
	PWMin = SeTBuf[13];
	PWMout = SeTBuf[14];
	timing = SeTBuf[15];
	slowP = Math.round(SeTBuf[16]/10);
	slowVolt = Math.round((((SeTBuf[17]<<8) + (SeTBuf[18]&0xff))/10)/0.25);
	cutVolt =  Math.round((((SeTBuf[19]<<8) + (SeTBuf[20]&0xff))/10)/0.25);
	reversible = SeTBuf[29];
	Mpole = ((SeTBuf[21])/2)-1;
	I2Cadr = SeTBuf[22];
	CalibCL = SeTBuf[23];
	CLMode = SeTBuf[24];
	CP = Math.round((((SeTBuf[25]<<8) + (SeTBuf[26]&0xff))/10)/0.25);
	CI = Math.round((((SeTBuf[27]<<8) + (SeTBuf[28]&0xff))/10)/0.25);
	
	
	setConfig(MinCommand,MaxCommand,StartAt,SoftStart,BrakeForce,SpinDir,AFW,inpSig ,PWMin,PWMout,timing,slowP,slowVolt,cutVolt,reversible,CLMode,CalibCL,I2Cadr,CP,CI,Mpole);
}


function setConfig(mi,ma,sta,soft,brake,spin,act,inp,inpPWM,outPWM,tim,slow,volt,cutoff,rev,clM,clC,i2c,cp,ci,mpole){
	var miArr = [];
	var maArr = [];
	var staArr = [];
	for(var i = 0; i< 150; i++){
		maArr.push(2000-(i*5));
		miArr.push(1000+(i*5));
		staArr.push(1050+(i*5));
	}
	genOpt(document.getElementById('micsel'),'mico',miArr,mi);
	genOpt(document.getElementById('macsel'),'maco',maArr,ma);
	genOpt(document.getElementById('stasel'),'stco',staArr,sta);	
	
	var softOpt = [];
	for(var i = 0; i<= 300;i++){
		softOpt.push(i);
	}
	genOpt(document.getElementById('softsel'),'softco',softOpt,soft);	
	
	var brakeVals = [];
	for(var i = 0;i<= 1000;i+=5){
		brakeVals.push(i);
	}
	genOpt(document.getElementById('braksel'),'brakco',brakeVals,brake);
	
	genOpt(document.getElementById('spinsel'),'spinco',['cw','ccw'],spin);
	
	genOpt(document.getElementById('afwsel'),'afwco',['off','on'],act);
	
	genOpt(document.getElementById('insigsel'),'insico',['PWM','iC'],inp);
	
	genOpt(document.getElementById('PWMsigsel'),'pwmSco',['50-500Hz','1kHz','Oneshot125'],inpPWM);
	
	genOpt(document.getElementById('PWMfreqsel'),'pwmOco',['6kHz','8kHz','12kHz','16kHz','24kHz','32kHz','48kHz','64kHz'],outPWM);
	
	genOpt(document.getElementById('timsel'),'timco',['0','7.5','15','22.5','30'],tim);
	
	genOpt(document.getElementById('slowsel'),'slowco',['0%','10%','20%','30%','40%','50%','60%','70%','80%','90%'],slow);
	
	var voltages = [];
	for(var i = 0; i< 30;i+= 0.25){
		voltages.push(i);
	}
	
	genOpt(document.getElementById('islowVsel'),'slowVco',voltages,volt);
	
	genOpt(document.getElementById('cutVolsel'),'cutVco',voltages,cutoff);
	
	genOpt(document.getElementById('revsel'),'revco',['off','on'],rev);
	
	genOpt(document.getElementById('clsel'),'clco',['off','on'],clM);
	
	genOpt(document.getElementById('cclwsel'),'cclco',['off','on'],clC);
	
	var i2cadresses = [];
	for(var i = 0; i<128;i++){
		 i2cadresses.push(i);
	}
	genOpt(document.getElementById('adrsel'),'i2cco',i2cadresses,i2c);
	
	var P_I = [];
	for(var i = 0; i< 30.25; i+=0.25){
		P_I.push(i);
	}
	genOpt(document.getElementById('P'),'CLPsel',P_I,cp);
	genOpt(document.getElementById('I'),'CLIsel',P_I,ci);
	
	var mpoleC = [];
	for(var i = 2;i < 62; i+=2){
		mpoleC.push(i);
	}
	genOpt(document.getElementById('Mpole'),'MpoleSet',mpoleC,mpole);
}


function getVal(id){
	return parseInt(document.getElementById(id).value);
}


function WriteSettings(){
	MinCommand = getVal('mico');
	MaxCommand = getVal('maco');
	StartAt = getVal('stco');
	SoftStart = getVal('softco');
	BrakeForce = getVal('brakco');
	SpinDir = getVal('spinco');
	AFW = getVal('afwco');
	inpSig = getVal('insico');
	PWMin = getVal('pwmSco');
	PWMout = getVal('pwmOco');
	timing = getVal('timco');
	slowP = getVal('slowco');
	slowVolt = getVal('slowVco');
	cutVolt = getVal('cutVco');
	reversible = getVal('revco');
	Mpole = getVal('MpoleSet');
	I2Cadr = getVal('i2cco');
	CalibCL = getVal('cclco');
	CLMode = getVal('clco');
	CP = getVal('CLPsel');
	CI = getVal('CLIsel');	
	

	var settingString = 'C';
	
	settingString += (Math.round((1000+(MinCommand*5)))>>8)+";"+(Math.round((1000+(MinCommand*5)))&0xff)+";";
	settingString += (Math.round((2000-(MaxCommand*5)))>>8)+";"+(Math.round((2000-(MaxCommand*5)))&0xff)+";";
	settingString += (Math.round((1050+(StartAt*5)))>>8)+";"+(Math.round((1050+(StartAt*5)))&0xff)+";";
	settingString += (SoftStart>>8)+";"+(SoftStart&0xff)+";";
	settingString += (BrakeForce>>8)+";"+(BrakeForce&0xff)+";";
	settingString += SpinDir+";";
	settingString += AFW+";";
	settingString += inpSig+";";
	settingString += PWMin+";";
	settingString += PWMout+";";
	settingString += timing+";";
	settingString += (slowP*10)+";";
	settingString += (Math.round(((slowVolt*0.25)*10))>>8)+";"+(Math.round(((slowVolt*0.25)*10))&0xff)+";";
	settingString += (Math.round(((cutVolt*0.25)*10))>>8)+";"+(Math.round(((cutVolt*0.25)*10))&0xff)+";";
	settingString += (Math.round((Mpole+1)*2))+";";
	settingString += I2Cadr+";";
	settingString += CalibCL+";";
	settingString += CLMode+";";
	settingString += (Math.round(((CP*0.25)*10))>>8)+";"+(Math.round(((CP*0.25)*10))&0xff)+";";
	settingString += (Math.round(((CI*0.25)*10))>>8)+";"+(Math.round(((CI*0.25)*10))&0xff)+";";
	settingString += reversible+";";
	Write(settingString);
	setConfig(MinCommand,MaxCommand,StartAt,SoftStart,BrakeForce,SpinDir,AFW,inpSig ,PWMin,PWMout,timing,slowP,slowVolt,cutVolt,reversible,CLMode,CalibCL,I2Cadr,CP,CI,Mpole);
}





function checkLiveData(){
	
	
	
	var tmpNeu = ((LDBuf[15]<<8) + (LDBuf[14]&0xff));
	
	if(tmpNeu  > 32767) (tmpNeu  -=65535);
	TMP.push(tmpNeu);
	document.getElementById('tempd').innerHTML = TMP[TMP.length-1];
	if(TMP.length > 200){
		TMP = TMP.slice(1,201);
	}
	
	PWM.push(((LDBuf[1]<<8) + (LDBuf[0]&0xff))/14);
	document.getElementById('PWMd').innerHTML = ((LDBuf[1]<<8) + (LDBuf[0]&0xff));
	if(PWM.length > 200){
		PWM = PWM.slice(1,201);
	}
	
	Rrpm = (LDBuf[3]<<8) + (LDBuf[2]&0xff);
	Rrpm = (16000000*60)/((Rrpm*6)*(Mpole+1));
	if(Rrpm > 64000) Rrpm = 0;
	Rrpm = Math.round(Rrpm);
	document.getElementById('RPMd').innerHTML = Rrpm;
	RPM.push(Rrpm/180);
	if(RPM.length > 200){
		RPM = RPM.slice(1,201);
	}
	
	Volt.push(((LDBuf[5]<<8) + (LDBuf[4]&0xff))/2);
	document.getElementById('voltd').innerHTML = ((LDBuf[5]<<8) + (LDBuf[4]&0xff))/10;
	if(Volt.length > 200){
		Volt = Volt.slice(1,201);
	}
	Curr.push(((LDBuf[7]<<8) + (LDBuf[6]&0xff))/2);
	document.getElementById('curd').innerHTML = ((LDBuf[7]<<8) + (LDBuf[6]&0xff))/10;
	if(Curr.length > 200){
		Curr = Curr.slice(1,201);
	}	
	
	canvasCont.clearRect(0, 0, 400, 150);
	
	drawLine(TMP,'#999999');
	drawLine(PWM,'#3366CC');
	drawLine(RPM,'#CC3399');
	drawLine(Volt,'#66CCCC');
	drawLine(Curr,'#CC9900');
	
	document.getElementById('tshow').style.width = (((((LDBuf[9]<<8) + (LDBuf[8]&0xff))/2)-800)/15)+'px';
	document.getElementById('tval').innerHTML = (((LDBuf[9]<<8) + (LDBuf[8]&0xff))/2);
	
	
}

/*
	startB.removeAttribute("disabled");
	stopB.removeAttribute("disabled");
	readB.removeAttribute("disabled");
	writeB.removeAttribute("disabled");

*/

function startLD(){
	startB.setAttribute("disabled","disabled");
	readB.setAttribute("disabled","disabled");
	writeB.setAttribute("disabled","disabled");
	live_data_active = 1;
	pullData();
}
function stopLD(){
	startB.removeAttribute("disabled");
	readB.removeAttribute("disabled");
	writeB.removeAttribute("disabled");
	live_data_active = 0;
}



function drawLine(arr,color){
	canvasCont.beginPath();
	if(arr[0]){
		canvasCont.moveTo(0,150-Math.round(arr[0]));
	}else{
		canvasCont.moveTo(0,150);
	}
	for(var i = 0; i<400; i++){
		if(arr[i]){
			canvasCont.lineTo(i*2,150-Math.round(arr[i]));
		}else{
			canvasCont.lineTo(i*2,150);
		}
	}
	canvasCont.strokeStyle = color;
	canvasCont.stroke();	
}


function genOpt(obj,id,valsArr,selected){
	var opt = document.createElement('select');
	opt.id = id;
	opt.value = '0';
	for(var i=0;i< valsArr.length;i++){
		var portOpt = document.createElement('option');
		portOpt.value = i;
		portOpt.innerHTML = valsArr[i];
		if(i == selected){
			portOpt.selected = 'selected';
		}
		opt.appendChild(portOpt);
	}
	obj.innerHTML = '';
	obj.appendChild(opt);	
	
}


//_______________________________________________________________________//









//_______________________________________________________________________//

onload = function(){
	chrome.serial.getDevices(function(ports){
		openPort(ports);
	});
}

onclose = function(){
	chrome.serial.disconnect(connId.connectionId, function(){});
	
};

//part of chrome serial lib
/**
Copyright 2012 Google Inc.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

     http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

Author: Renato Mangini (mangini@chromium.org)
Author: Luis Leao (luisleao@gmail.com)
**/

var str2ab = function (str) {
        var buf = new ArrayBuffer(str.length);
        var bufView = new Uint8Array(buf);
        for (var i = 0; i < str.length; i++) {
            bufView[i] = str.charCodeAt(i);
        }
        return buf;
};










